#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum IngestTransformType {
    #[serde(rename = "CONTAINERIZED")]
    Containerized,
    #[serde(rename = "MCAP")]
    Mcap,
    #[serde(rename = "DATAFLASH")]
    Dataflash,
    #[serde(rename = "PARQUET_ARCHIVE")]
    ParquetArchive,
    #[serde(rename = "FILE_COPY")]
    FileCopy,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl IngestTransformType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            IngestTransformType::Containerized => "CONTAINERIZED",
            IngestTransformType::Mcap => "MCAP",
            IngestTransformType::Dataflash => "DATAFLASH",
            IngestTransformType::ParquetArchive => "PARQUET_ARCHIVE",
            IngestTransformType::FileCopy => "FILE_COPY",
            IngestTransformType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for IngestTransformType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for IngestTransformType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for IngestTransformType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<IngestTransformType, conjure_object::plain::ParseEnumError> {
        match v {
            "CONTAINERIZED" => Ok(IngestTransformType::Containerized),
            "MCAP" => Ok(IngestTransformType::Mcap),
            "DATAFLASH" => Ok(IngestTransformType::Dataflash),
            "PARQUET_ARCHIVE" => Ok(IngestTransformType::ParquetArchive),
            "FILE_COPY" => Ok(IngestTransformType::FileCopy),
            v => v.parse().map(|v| IngestTransformType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for IngestTransformType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<IngestTransformType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the IngestTransformType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
